//
// NETDEMO
// Copyright (c) 2003 Rama C. Hoetzlein
//

#include <conio.h>
#include <time.h>
#include <stdio.h>
#include <winsock2.h>

#include "netdemo-eng.h"

// This demo is UDP Chat Server and Client. Multiple clients
// can connect to the server, and the server will echo keyboard input
// from each client back to every other client connected.

// NOTE: IN ORDER FOR THIS DEMO TO WORK, YOU MUST LINK IN WS2_32.lib
// WHICH IS THE STANDARD WINSOCK2 SOCKETS LIBRARY.

NetEng e;
int mode;

void main (void)
{
	int key = 0;
	int from_who;
	printf ("Press 'c' for client, 's' for server.\n");
	key = _getch();
	if (key=='c')	mode = NET_CLIENT;
	else			mode = NET_SERVER;
	
	e.Start (mode);
	
	for (;;) {
		e.Go ();	// Process networking events
		
		switch (mode) {
		case NET_CLIENT: {		//*** CLIENT
			// If client presses a key, send it to server.
			if (_kbhit()) 
				e.SendByteToServer (_getch());
			// If server sends us a key, display it.
			key = e.RecieveByte (&from_who);
			if (key!=-1) {
				printf ("%c", key);
				if (key==13) printf ("\n");
			}
		} break;
		case NET_SERVER: {		//*** SERVER
			key = e.RecieveByte (&from_who);
			if (key!=-1) {
				int num_clients = e.GetNumClients();
				e.SendByteToClients (key);
				if (key==13) key = '.';
				printf ("Data: Recieved %c from client %d. Sending to clients 1..%d\n", key, from_who, num_clients);				
			}
			if (_kbhit()) {
				key = _getch();
				e.SendByteToClients (key);
				if (key==13) key = '.';
				printf ("Data: Sent %c to clients from server itself.\n", key);
			}
		} break;
		}
	}
}
